(define-module (ui auth-token ajax)
  :use-module (alterator ajax)
  :use-module (alterator woo)
  :use-module (alterator algo)
  :export (on-load))

(define (ui-read)
  (catch/message
   (lambda()
     (form-update-value-list
      (woo-read-first "/auth-token"
                      'language (form-value "language"))))))

(define (ui-apply)
  (catch/message
   (lambda()
     (woo-write "/auth-token" 'language (form-value "language")
                              'enabled (form-value "enabled")
                              'profile (form-value "profile")
                              'autoadd (form-value "autoadd")
                              'gost (form-value "gost"))))
  (ui-read))

(define (ui-reset)
  (catch/message
   (lambda()
     (form-update-enum "name" (woo-list "/auth-token/profiles"
                                        'language (form-value "language")))))
  (ui-read)
  (let ((preset (form-session-ref "preset")))
    (if preset
      (let ((profile (cond-assoc 'profile preset))
            (gost (cond-assoc 'gost preset))
            (autoadd (cond-assoc 'autoadd preset)))
        (if profile (form-update-value "profile" profile))
        (if gost (form-update-value "gost" (not (equal? gost "0"))))
        (if autoadd (form-update-value "autoadd" (not (equal? autoadd "0"))))))))

(define (on-load)
  (form-bind "apply" "click" ui-apply)
  (form-bind "reset" "click" ui-reset)
  (form-session-set! "ui-apply" ui-apply)
  (ui-reset))
